﻿@{
    Layout = "~/_SiteLayout.cshtml";
    Page.Title = "Gifts for Couples";

    var email = "";
    try {
        email = Session["username"].ToString();
    } catch {
        Context.RedirectLocal("~/Account/Login");
    }

    var code = UrlData[0].ToString();
    var db = Database.Open("webdev");
    var owner = db.QueryValue("SELECT Owner FROM Weddings WHERE Code = @0", code).ToString();
    var itemname = "";  
    var picked = "";
    bool isOwner = (owner == email);
    int numGift = 0;

    if(isOwner) {
        Page.Description = " (your wedding)";
    } else {
        Page.Description = " (not starred)";
    }

    var gifts = db.Query("SELECT Priority, ItemName, Gifter FROM Gifts WHERE Wedding_ID = @0 ORDER BY Priority ASC", code);


    if (IsPost) {
//        AntiForgery.Validate();

        if (Validation.IsValid()) {
            var message = Request.Form["message"];
            if(message == "additem"){
                itemname = Request.Form["itemname"];
                var prio = db.Query("SELECT MAX(Priority) AS MaxPrio FROM Gifts WHERE Wedding_ID = @0", code);

                int priority = 0;
                foreach(var p in prio) {
                    if(p.MaxPrio == null) {
                        priority = 0;
                    } else {
                        priority = p.MaxPrio;
                    }
                } // get max priority from query

                var qRes = db.Query("INSERT INTO Gifts (Wedding_ID, Priority, Itemname, Gifter) VALUES (@0, @1, @2, @3)", code, priority + 1, itemname.ToString(), null);
            } else if(message == "deleteitem") {
                var itemnr = Request.Form["itemnr"];
                db.Query("DELETE FROM Gifts WHERE Wedding_ID = @0 AND Priority = @1", code, itemnr);

                var fixPrios = db.Query("SELECT id FROM Gifts WHERE Wedding_ID = @0 AND Priority > @1", code, itemnr);
                int newPrio = Convert.ToInt32(itemnr);

                foreach( var fix in fixPrios) {
                    db.Query("UPDATE Gifts SET Priority = @0 WHERE id = @1", newPrio, fix.id);
                    newPrio++;
                }
                // fix priorities
            } else if(message == "upitem") {
                var prio = Request.Form["itemnr"];
                int priority = Convert.ToInt32(prio);
                int idup = db.QueryValue("SELECT id FROM Gifts WHERE Wedding_ID = @0 AND Priority = @1", code, priority);
                int iddown = db.QueryValue("SELECT id FROM Gifts WHERE Wedding_ID = @0 AND Priority = @1", code, priority - 1);
                // het is maar goed dat we geen 16 gifts om hoeven te wisselen

                db.Query("UPDATE Gifts SET Priority = @0 WHERE id = @1", priority - 1, idup);
                db.Query("UPDATE Gifts SET Priority = @0 WHERE id = @1", priority, iddown);
            } else if(message == "downitem") {
                var prio = Request.Form["itemnr"];

                int iddown = db.QueryValue("SELECT id FROM Gifts WHERE Wedding_ID = @0 AND Priority = @1", code, Convert.ToInt32(prio) );
                int idup = db.QueryValue("SELECT id FROM Gifts WHERE Wedding_ID = @0 AND Priority = @1", code, Convert.ToInt32(prio) + 1);
                // het is maar goed dat we geen 16 gifts om hoeven te wisselen

                db.Query("UPDATE Gifts SET Priority = @0 WHERE id = @1", Convert.ToInt32(prio), idup);
                db.Query("UPDATE Gifts SET Priority = @0 WHERE id = @1", Convert.ToInt32(prio) + 1, iddown);
            } else if(message == "pick") {
                var prio = Request.Form["itemnr"];
                db.Query("UPDATE Gifts SET Gifter = @0 WHERE Wedding_ID = @1 AND Priority = @2", email, code, Convert.ToInt32(prio));                
            } else if(message == "unpick") {
                var prio = Request.Form["itemnr"];
                db.Query("UPDATE Gifts SET Gifter = @0 WHERE Wedding_ID = @1 AND Priority = @2", null, code, Convert.ToInt32(prio));                                
            }
            Context.RedirectLocal("~/Gifts/"+code); // clear the post for F5'ing
        }
    }
}

<hgroup class="title">
    <h1>@Page.Title</h1>
    <h2>@Page.Description</h2>
</hgroup>

@if(gifts.Count() == 0) {
    <h4>No Items yet</h4>
}else {
    <h4>You have @gifts.Count() items in this wishlist.</h4>
    <table>
        <tr>
            <th>Item: </th>
            <th>Picked: </th>
            @if(isOwner) {
                <th></th>
                <th>Edit:</th>
                <th></th>
            }
        </tr>
        @foreach(var g in gifts) {
            numGift++;
            picked = "";
            <tr>
                <td>
                    @g.Priority | 
                    @g.ItemName</td>
                <td>@if(owner == email) {
                        if(string.IsNullOrEmpty(g.Gifter)) {
                            picked = "Not picked!";
                        } else {
                            picked = "Picked!";
                        }
                    } else {
                        if(!string.IsNullOrEmpty(g.Gifter) && g.Gifter.ToString() != email) {
                            picked = "Picked by " + g.Gifter;
                        } else if(string.IsNullOrEmpty(g.Gifter)){
                            <form method="post">
                                <input type="hidden" name="message" value="pick">
                                <input type="hidden" name="itemnr" value=@g.Priority>
                                <input type="submit" value="Pick">
                            </form>
                        } else if(g.gifter.ToString() == email) {
                            <form method="post">
                                <input type="hidden" name="message" value="unpick">
                                <input type="hidden" name="itemnr" value=@g.Priority>
                                <input type="submit" value="Unpick">
                            </form>
                        }
                    }
                    @picked</td>
                @if(isOwner) {
                    <td>
                        <form method="post"> 
                        @if(numGift != 1) {//is first item
                                <input type="hidden" name="message" value="upitem">
                                <input type="hidden" name="itemnr" value=@g.Priority>                           
                        }
                        <input type="submit" value="Up">
                        </form>
                    </td>
                    <td>
                        <form method="post">
                        @if(numGift != gifts.Count()){ //is last item
                            <input type="hidden" name="message" value="downitem">
                            <input type="hidden" name="itemnr" value=@g.Priority>
                        }
                        <input type="submit" value="Down">
                        </form>
                    </td>
                    <td><form method="post">
                        <input type="hidden" name="message" value="deleteitem">
                        <input type="hidden" name="itemnr" value=@g.Priority>
                        <input type="submit" value="Delete">
                    </form></td>
                }
            </tr>
        }
    </table>
}

@if(isOwner) {
    <form method="post">
         <fieldset>
            <ol>
                <li class="itemname">
                    <h3>Add a new item</h3>
                    <label for="itemname" @if (!ModelState.IsValidField("itemname")) {<text>class="error-label"</text>}></label>
                    <input type="text" id="itemname" name="itemname" value="@itemname" @Validation.For("itemname")/>
                    <input type="hidden" name="message" value="additem" />
                    @* Write any user name validation errors to the page *@
                    @Html.ValidationMessage("itemname")
                </li>
                <li>
                    <input type="submit" value="Insert" />
                </li>
            </ol>
        </fieldset>
    </form>
} 